DIR-3059 Extend OBDFCASCRAPE to be able to download Cypriot NCA Credit Institute data

# Summary

* Implement Credit Institute scraping
* Extended test to test Credit Institute scraping

# Test Plan

* Run All tests

```
# CYPRUS:: Scrape a Credit Service
# CYPRUS::Extract Local Credit Institutions from Page
ok 1 Extracted Local Credit Institutions from Page
# CYPRUS::Extract Foreign Credit Institutions from Page
ok 2 Extracted Foreign Credit Institutions from Page
# CYPRUS::Extract ALL Credit Institutions from Page
[2018-11-06T16:25:36.859] [INFO] CY - Credit institutes
[2018-11-06T16:25:36.867] [INFO] Scraper - fullPath tests/sink/201811061625
[2018-11-06T16:25:36.871] [DEBUG] Scraper - Snapshot tests/sink/201811061625/creditInstitutes.png
ok 3 Extracted ALL Credit Institutions from Page

1..3
# tests 3
# pass  3

# ok

# CYPRUS::WHOIS Test
CMD dig www.centralbank.cy +time=3 +retry=1
ok 1 Get Raw CY WhoIS
ok 2 No JSON for Cyprus
ok 3 Get JSON WhoIS for IP Address
# CYPRUS::SSL Test
[2018-11-06T16:19:50.502] [DEBUG] Scraper - Cert for: www.centralbank.cy
ok 4 Get SSL Certificate

1..4
# tests 4
# pass  4

# ok

```
